package com.dsic.gj_erp.controller.jhgk;


import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmJtsyjh;
import com.dsic.gj_erp.bean.jhgk.DmXbjh;
import com.dsic.gj_erp.service.jhgk.DmJtsyjhService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/dmJtsyjh")
@Api(tags = "集团三月滚动计划")
public class DmJtsyjhController {
    @Autowired
    DmJtsyjhService dmJtsyjhService;

    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody JSONObject json) {
        List<DmJtsyjh> dmXbjhs= dmJtsyjhService.getList(json);
        return new ResultBean(dmXbjhs);
    }

    @ApiOperation(value = "导入excel")
    @PostMapping(value = "/upload")
    public ResultBean upload(@RequestParam(value = "file") MultipartFile file) throws IOException {
        List<DmJtsyjh> dmXbjhs= dmJtsyjhService.upload(file);
        return new ResultBean(dmXbjhs);
    }

    @ApiOperation(value = "批量保存")
    @PostMapping(value = "/save")
    public ResultBean save(@RequestBody List<DmJtsyjh> dmJtsyjhs) {
        dmJtsyjhService.save(dmJtsyjhs);
        return new ResultBean();
    }

    @ApiOperation(value = "批量提交")
    @PostMapping(value = "/tj")
    public ResultBean tj(@RequestBody List<DmJtsyjh> dmJtsyjhs) {
        dmJtsyjhService.tj(dmJtsyjhs);
        return new ResultBean();
    }
}

