package com.dsic.gj_erp.service.jcsj.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.mapper.jcsj.DmBomMapper;
import com.dsic.gj_erp.service.jcsj.DmBomService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-25
 */
@Service
public class DmBomServiceImpl extends ServiceImpl<DmBomMapper, DmBom> implements DmBomService {

    @Autowired
    BomUploadServiceImpl bomUploadService;
    @Override
    public List<DmBom> getListBom(Map map) throws CustomException {
        List<DmBom> list = this.list(new QueryWrapper<DmBom>().eq("sjch", map.get("dcch"))
            .eq(StrUtil.isNotEmpty((String) map.get("fd")), "fd", map.get("dcfd"))
            .eq(StrUtil.isNotEmpty((String) map.get("pl")), "fd", map.get("dcpl"))
        );

        if(list.size()<=0){

            throw new CustomException(10105, "为老系统数据 请点击生成Bom");
        }
        return list;
    }

    @Override
    public void insertBoms(List<DmBom> map) throws CustomException {
        map.forEach(e->{
            baseMapper.insertBom(e);
        });

    }
}
