package com.dsic.gj_erp.service.jcsj.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jcsj.DmCzplp;
import com.dsic.gj_erp.bean.jcsj.DmCzplpNew;
import com.dsic.gj_erp.bean.jcsj.excel.PlExcel;
import com.dsic.gj_erp.bean.jhgk.DmTzjh;
import com.dsic.gj_erp.mapper.jcsj.DmCzplpNewMapper;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jcsj.DmCzplpNewService;
import com.dsic.gj_erp.service.jcsj.DmCzplpService;
import com.dsic.gj_erp.service.jhgk.DmTzjhService;
import com.dsic.gj_erp.service.sy.SYService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-11
 */
@Service
public class DmCzplpNewServiceImpl extends ServiceImpl<DmCzplpNewMapper, DmCzplpNew> implements DmCzplpNewService {
    @Autowired
    DmCzplpService dmCzplpService;
    @Autowired
    DmCbxxpService dmCbxxpService;
    @Autowired
    SYService syService;

    @Autowired
    DmTzjhService dmTzjhService;

    /**
     *
     * @param list
     * @param project
     * @param isupload 如果覆盖传入01 如果返回的是 01 提示是否覆盖 02 不提示
     * @param req
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Map uploadPl(List<PlExcel> list, String project, String isupload, HttpServletRequest req) {
        Map returnMap = new HashMap();
        List<String> pls = list.stream().filter(f -> StringUtils.isNotBlank(f.getDcPL())).map(PlExcel::getDcPL).collect(Collectors.toList());
        List<DmCzplpNew> fdList = this.list(new QueryWrapper<DmCzplpNew>().in("dc_pl", pls));
//        if(fdList.size()>0){
//          // 是否覆盖之前导入的数据
//          if(!isupload.equals("01")){
//              returnMap.put("zt","01");
//          }
//        }else{
//            returnMap.put("zt","02");
//        }
        List<DmCzplpNew> dmCzplpNews = new ArrayList<>();
        List<DmCzplp> dmCzplps = new ArrayList<>();
        for (PlExcel plExcel : list) {
            Map map = getPlCount(plExcel);
            int plCount = (int) map.get("plcount");
            String fds = (String) map.get("fds");
            Map<String, Object> stringObjectMap = BeanUtil.beanToMap(plExcel);
            DmCzplpNew dmCzplpNewOld = fdList.stream().filter(fst -> plExcel.getDcPL().equals(fst.getDcPl())).findFirst().orElse(null);

            if (null != dmCzplpNewOld) {
                this.remove(new QueryWrapper<DmCzplpNew>().eq("dc_pl", plExcel.getDcPL()));
                for (int i = 1; i <plCount; i++) {
                    DmCzplpNew dmCzplpNew = plexcltoDmczplNewUp(plExcel, stringObjectMap, req, i, dmCzplpNewOld);
                    dmCzplpNews.add(dmCzplpNew);
                }
            } else {
                for (int i = 1; i <plCount; i++) {
                    Map mapBean = plexcltoDmczplNew(plExcel, stringObjectMap, req, i, fds);
                    dmCzplpNews.add((DmCzplpNew) mapBean.get("dmCzplpNew"));
                    dmCzplps.add((DmCzplp) mapBean.get("dmCzplp"));
                }
            }
        }
        if (dmCzplpNews.size() > 0) {
            this.saveBatch(dmCzplpNews);
            List<DmTzjh>tzjhs=new ArrayList<>();
            dmCzplpNews.forEach(e->{
                DmTzjh tzjh=new DmTzjh();
                tzjh.setDcPl(e.getDcPl());
                tzjh.setDcFd(e.getDcFd());
                tzjh.setDcCh(e.getDcCh());
                tzjh.setXfqTlt(e.getXfqTlt());
                tzjh.setXfqLqb(e.getXfqLqb());
                tzjh.setXfqPtb(e.getXfqPtb());
                tzjhs.add(tzjh);
            });
            dmTzjhService.saveBatch(tzjhs);
        }


        if (dmCzplps.size() > 0) {
            dmCzplpService.saveBatch(dmCzplps);
        }
        return returnMap;
    }

    public Map getPlCount(PlExcel plExcel) {
        Map map = new HashMap();
        int plcount = 1;
        String pls = "";
        String dcPl1 = plExcel.getDcFd1();
        String dcPl2 = plExcel.getDcFd2();
        String dcPl3 = plExcel.getDcFd3();
        String dcPl4 = plExcel.getDcFd4();
        String dcPl5 = plExcel.getDcFd5();
        String dcPl6 = plExcel.getDcFd6();
        String dcPl7 = plExcel.getDcFd7();
        String dcPl8 = plExcel.getDcFd8();
        if (StringUtils.isNotBlank(dcPl1)) {
            plcount++;
            pls = pls + dcPl1;
        }
        if (StringUtils.isNotBlank(dcPl2)) {
            plcount++;
            pls = pls + " " + dcPl2;
        }
        if (StringUtils.isNotBlank(dcPl3)) {
            plcount++;
            pls = pls + " " + dcPl3;
        }
        if (StringUtils.isNotBlank(dcPl4)) {
            plcount++;
            pls = pls + " " + dcPl4;
        }
        if (StringUtils.isNotBlank(dcPl5)) {
            plcount++;
            pls = pls + " " + dcPl5;
        }
        if (StringUtils.isNotBlank(dcPl6)) {
            plcount++;
            pls = pls + " " + dcPl6;
        }
        if (StringUtils.isNotBlank(dcPl7)) {
            plcount++;
            pls = pls + " " + dcPl7;
        }
        if (StringUtils.isNotBlank(dcPl8)) {
            plcount++;
            pls = pls + " " + dcPl8;
        }
        map.put("plcount", plcount);
        map.put("pls", pls.trim());
        return map;
    }

    public Map plexcltoDmczplNew(PlExcel plExcel, Map stringObjectMap, HttpServletRequest req, int i, String fds) {
        DmCzplpNew dmCzplpNew = new DmCzplpNew();
        DmCzplp dmCzplp = new DmCzplp();
        String id = syService.f_getpjh("DM", "DM", "CZPL");
        dmCzplp.setId(id);
        dmCzplp.setDcCh(plExcel.getDcCh());
        dmCzplp.setDcFd(fds);
        dmCzplp.setZl(plExcel.getZl());
        dmCzplp.setDcPl(plExcel.getDcPL());
        dmCzplp.setLrr((String) req.getAttribute("yhms"));
        dmCzplp.setLrrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        dmCzplpNew.setDcPl(plExcel.getDcPL());
        dmCzplpNew.setDcCh(plExcel.getDcCh());
        dmCzplpNew.setDcFd((String) stringObjectMap.get("dcFd" + i ));
        dmCzplpNew.setZl(plExcel.getZl());
        dmCzplpNew.setLrr((String) req.getAttribute("yhms"));
        dmCzplpNew.setLrrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        dmCzplpNew.setQy(plExcel.getQy());
        dmCzplpNew.setZdh(plExcel.getZdh());
        dmCzplpNew.setGdqJt(plExcel.getGdqJt());
        dmCzplpNew.setDzjsq(plExcel.getDzjsq());
        dmCzplpNew.setDzjsqZrc(plExcel.getDzjsqZrc());
        dmCzplpNew.setXzjsq(plExcel.getXzjsq());
        dmCzplpNew.setXzjsqZrc(plExcel.getXzjsqZrc());
        dmCzplpNew.setGjks(plExcel.getGjks());
        dmCzplpNew.setGjksZrc(plExcel.getGjksZrc());
        dmCzplpNew.setDhqc(plExcel.getDhqc());
        dmCzplpNew.setXfqTlt(plExcel.getXfqTlt());
        dmCzplpNew.setJsqTlt(plExcel.getJsqTlt());
        dmCzplpNew.setXfqLqb(plExcel.getXfqLqb());
        dmCzplpNew.setJsqLqb(plExcel.getJsqLqb());
        dmCzplpNew.setXfqPtb(plExcel.getXfqPtb());
        dmCzplpNew.setJsqPtb(plExcel.getJsqPtb());
        dmCzplpNew.setSlDz(plExcel.getSlDz());
        dmCzplpNew.setSlXz(plExcel.getSlXz());
        dmCzplpNew.setQtqDz(plExcel.getQtqDz());
        dmCzplpNew.setQtqXz(plExcel.getQtqXz());
        dmCzplpNew.setFdxqq(plExcel.getFdxqq());
        dmCzplpNew.setSjpsq(plExcel.getSjpsq());
        dmCzplpNew.setDhqd(plExcel.getDhqd());
        dmCzplpNew.setXfqDhqd(plExcel.getXfqDhqd());
        dmCzplpNew.setSjdhrq(plExcel.getSjdhrq());
        dmCzplpNew.setBcdq(plExcel.getBcdq());
        dmCzplpNew.setSjarrival(plExcel.getSjarrival());
        dmCzplpNew.setJsbs(plExcel.getJsbs());
        dmCzplpNew.setZt("0");
        dmCzplpNew.setXzjsqsm("");
        dmCzplpNew.setId(id);
        dmCzplpNew.setXfqLqb1sm("");
        dmCzplpNew.setXfqTlt1(plExcel.getXfqTlt());
        dmCzplpNew.setDzjsq1(plExcel.getDzjsq());
        dmCzplpNew.setXfqTltsm("");
        dmCzplpNew.setDzjsqsm("");
        dmCzplpNew.setGjks1(plExcel.getGjks());
        dmCzplpNew.setXfqDhqd1(plExcel.getXfqDhqd());
        dmCzplpNew.setGjkssm("");
        dmCzplpNew.setXzjsq1(plExcel.getXzjsq());
        dmCzplpNew.setXfqDhqd1sm("");
        dmCzplpNew.setXfqLqb1(plExcel.getXfqLqb());
        Map map = new HashMap();
        map.put("dmCzplp", dmCzplp);
        map.put("dmCzplpNew", dmCzplpNew);
        return map;
    }

    public DmCzplpNew plexcltoDmczplNewUp(PlExcel plExcel, Map stringObjectMap, HttpServletRequest req, int i, DmCzplpNew dmCzplpNewOld) {
        DmCzplpNew dmCzplpNew = new DmCzplpNew();
        String id = syService.f_getpjh("DM", "DM", "CZPL");
        dmCzplpNew.setDcPl(plExcel.getDcPL());
        dmCzplpNew.setDcCh(plExcel.getDcCh());
        dmCzplpNew.setDcFd((String) stringObjectMap.get("dcFd" + i ));
        dmCzplpNew.setZl(plExcel.getZl());
        dmCzplpNew.setLrr((String) req.getAttribute("yhms"));
        dmCzplpNew.setLrrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
        dmCzplpNew.setQy(plExcel.getQy());
        dmCzplpNew.setZdh(plExcel.getZdh());
        dmCzplpNew.setGdqJt(plExcel.getGdqJt());
        dmCzplpNew.setDzjsq(plExcel.getDzjsq());
        dmCzplpNew.setDzjsqZrc(plExcel.getDzjsqZrc());
        dmCzplpNew.setXzjsq(plExcel.getXzjsq());
        dmCzplpNew.setXzjsqZrc(plExcel.getXzjsqZrc());
        dmCzplpNew.setGjks(plExcel.getGjks());
        dmCzplpNew.setGjksZrc(plExcel.getGjksZrc());
        dmCzplpNew.setDhqc(plExcel.getDhqc());
        dmCzplpNew.setXfqTlt(plExcel.getXfqTlt());
        dmCzplpNew.setJsqTlt(plExcel.getJsqTlt());
        dmCzplpNew.setXfqLqb(plExcel.getXfqLqb());
        dmCzplpNew.setJsqLqb(plExcel.getJsqLqb());
        dmCzplpNew.setXfqPtb(plExcel.getXfqPtb());
        dmCzplpNew.setJsqPtb(plExcel.getJsqPtb());
        dmCzplpNew.setSlDz(plExcel.getSlDz());
        dmCzplpNew.setSlXz(plExcel.getSlXz());
        dmCzplpNew.setQtqDz(plExcel.getQtqDz());
        dmCzplpNew.setQtqXz(plExcel.getQtqXz());
        dmCzplpNew.setFdxqq(plExcel.getFdxqq());
        dmCzplpNew.setSjpsq(plExcel.getSjpsq());
        dmCzplpNew.setDhqd(plExcel.getDhqd());
        dmCzplpNew.setXfqDhqd(plExcel.getXfqDhqd());
        dmCzplpNew.setSjdhrq(plExcel.getSjdhrq());
        dmCzplpNew.setBcdq(plExcel.getBcdq());
        dmCzplpNew.setSjarrival(plExcel.getSjarrival());
        dmCzplpNew.setJsbs(plExcel.getJsbs());
        dmCzplpNew.setZt("0");
        dmCzplpNew.setId(id);
        String rq ="";
        String rqsm = "";
        int xfqLqb = DateUtil.compare(DateUtil.parse(plExcel.getXfqLqb()), DateUtil.parse(dmCzplpNewOld.getXfqLqb()), "MM");
        if (xfqLqb == 0) {
            xfqLqb = DateUtil.compare(DateUtil.parse(plExcel.getXfqLqb()), DateUtil.parse(dmCzplpNewOld.getXfqLqb()));
            if (xfqLqb != 0) {
                rqsm = "变更";
                rq = dmCzplpNewOld.getXfqLqb() + " " + plExcel.getXfqLqb();
            }else{
                rqsm = dmCzplpNewOld.getXfqLqb1sm();
                rq = dmCzplpNewOld.getXfqLqb1() ;
            }
        } else if (xfqLqb < 0) {
            rqsm = "托期";
            rq = dmCzplpNewOld.getXfqLqb() + " " + plExcel.getXfqLqb();
        } else if (xfqLqb > 0) {
            rqsm = "延期";
            rq = dmCzplpNewOld.getXfqLqb() + " " + plExcel.getXfqLqb();
        }
        dmCzplpNew.setXfqLqb1sm(rqsm);
        dmCzplpNew.setXfqLqb1(rq);
        int xzjsq = DateUtil.compare(DateUtil.parse(plExcel.getXzjsq()), DateUtil.parse(dmCzplpNewOld.getXzjsq()), "MM");
        if (xzjsq == 0) {
            xzjsq = DateUtil.compare(DateUtil.parse(plExcel.getXzjsq()), DateUtil.parse(dmCzplpNewOld.getXzjsq()));
            if (xzjsq != 0) {
                rqsm = "变更";
                rq = dmCzplpNewOld.getXzjsq() + " " + plExcel.getXzjsq();
            }else{
                rqsm = dmCzplpNewOld.getXzjsqsm();
                rq = dmCzplpNewOld.getXzjsq1() ;
            }
        } else if (xzjsq < 0) {
            rqsm = "托期";
            rq = dmCzplpNewOld.getXzjsq() + " " + plExcel.getXzjsq();
        } else if (xzjsq > 0) {
            rqsm = "延期";
            rq = dmCzplpNewOld.getXzjsq() + " " + plExcel.getXzjsq();
        }
        dmCzplpNew.setXzjsq1(rq);
        dmCzplpNew.setXzjsqsm(rqsm);
        int xfqTlt = DateUtil.compare(DateUtil.parse(plExcel.getXfqTlt()), DateUtil.parse(dmCzplpNewOld.getXfqTlt()), "MM");
        if (xfqTlt == 0) {
            xfqTlt = DateUtil.compare(DateUtil.parse(plExcel.getXfqTlt()), DateUtil.parse(dmCzplpNewOld.getXfqTlt()));
            if (xfqTlt != 0) {
                rqsm = "变更";
                rq = dmCzplpNewOld.getXfqTlt() + " " + plExcel.getXfqTlt();
            }else{
                rqsm = dmCzplpNewOld.getXfqTltsm();
                rq = dmCzplpNewOld.getXfqTlt1() ;
            }
        } else if (xfqTlt < 0) {
            rqsm = "托期";
            rq = dmCzplpNewOld.getXfqTlt() + " " + plExcel.getXfqTlt();
        } else if (xfqTlt > 0) {
            rqsm = "延期";
            rq = dmCzplpNewOld.getXfqTlt() + " " + plExcel.getXfqTlt();
        }
        dmCzplpNew.setXfqTltsm(rqsm);
        dmCzplpNew.setXfqTlt1(rq);
        int dzjsq = DateUtil.compare(DateUtil.parse(plExcel.getDzjsq()), DateUtil.parse(dmCzplpNewOld.getDzjsq()), "MM");
        if (dzjsq == 0) {
            dzjsq = DateUtil.compare(DateUtil.parse(plExcel.getDzjsq()), DateUtil.parse(dmCzplpNewOld.getDzjsq()));
            if (dzjsq != 0) {
                rqsm = "变更";
                rq = dmCzplpNewOld.getDzjsq() + " " + plExcel.getDzjsq();
            }else{
                rqsm = dmCzplpNewOld.getDzjsqsm();
                rq = dmCzplpNewOld.getDzjsq1() ;
            }
        } else if (dzjsq < 0) {
            rqsm = "托期";
            rq = dmCzplpNewOld.getDzjsq() + " " + plExcel.getDzjsq();
        } else if (dzjsq > 0) {
            rqsm = "延期";
            rq = dmCzplpNewOld.getDzjsq() + " " + plExcel.getDzjsq();
        }
        dmCzplpNew.setDzjsqsm(rqsm);
        dmCzplpNew.setDzjsq1(rq);
        int gjks = DateUtil.compare(DateUtil.parse(plExcel.getGjks()), DateUtil.parse(dmCzplpNewOld.getGjks()), "MM");
        if (gjks == 0) {
            gjks = DateUtil.compare(DateUtil.parse(plExcel.getGjks()), DateUtil.parse(dmCzplpNewOld.getGjks()));
            if (gjks != 0) {
                rqsm = "变更";
                rq = dmCzplpNewOld.getGjks() + " " + plExcel.getGjks();
            }else{
                rqsm = dmCzplpNewOld.getGjkssm();
                rq = dmCzplpNewOld.getGjks1() ;
            }
        } else if (gjks < 0) {
            rqsm = "托期";
            rq = dmCzplpNewOld.getGjks() + " " + plExcel.getGjks();
        } else if (gjks > 0) {
            rqsm = "延期";
            rq = dmCzplpNewOld.getGjks() + " " + plExcel.getGjks();
        }
        dmCzplpNew.setGjks1(rq);
        dmCzplpNew.setGjkssm(rqsm);
        int xfqDhqd = DateUtil.compare(DateUtil.parse(plExcel.getXfqDhqd()), DateUtil.parse(dmCzplpNewOld.getXfqDhqd()), "MM");
        if (xfqDhqd == 0) {
            xfqDhqd = DateUtil.compare(DateUtil.parse(plExcel.getXfqDhqd()), DateUtil.parse(dmCzplpNewOld.getXfqDhqd()));
            if (xfqDhqd != 0) {
                rqsm = "变更";
                rq = dmCzplpNewOld.getXfqDhqd() + " " + plExcel.getXfqDhqd();
            }else{
                rqsm = dmCzplpNewOld.getXfqDhqd1sm();
                rq = dmCzplpNewOld.getXfqDhqd1() ;
            }
        } else if (xfqDhqd < 0) {
            rqsm = "托期";
            rq = dmCzplpNewOld.getXfqDhqd() + " " + plExcel.getXfqDhqd();
        } else if (xfqDhqd > 0) {
            rqsm = "延期";
            rq = dmCzplpNewOld.getXfqDhqd() + " " + plExcel.getXfqDhqd();
        }
        dmCzplpNew.setXfqDhqd1(rq);
        dmCzplpNew.setXfqDhqd1sm(rqsm);
        return dmCzplpNew;
    }

    @Override
    public Map getCzplBase(Map map) {
        Map returnMap = new HashMap();
        List<DmCbxxp> cbbm = dmCbxxpService.list(new QueryWrapper<DmCbxxp>().orderBy(true, true, "cbbm"));
        returnMap.put("cbbm", cbbm);
        return returnMap;
    }

    @Override
    public List<DmCzplpNew> getCzplList(Map map) {
        QueryWrapper<DmCzplpNew> qw = new QueryWrapper<>();
        qw.eq(StrUtil.isNotEmpty((String) map.get("dcch")), "dc_ch", (String) map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String) map.get("dcfd")), "dc_pl", (String) map.get("dcpl"));
        qw.orderBy(true, true, "len(dc_pl)","dc_pl");
        List<DmCzplpNew> list = this.list(qw);
        return list;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void czPlupdate(List<DmCzplpNew> list) {
        this.updateBatchById(list);
    }
}
