package com.dsic.gj_erp.service.jcsj.impl;


import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.dao.jcsj.EmGcrlRepository;
import com.dsic.gj_erp.mapper.jcsj.EmGcrlMapper;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.Year;
import java.util.Date;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Service
public class EmGcrlServiceImpl extends ServiceImpl<EmGcrlMapper, EmGcrl> implements EmGcrlService {

    @Resource
    EmGcrlMapper emGcrlMapper;
    @Resource
    EmGcrlRepository emGcrlRepository;


    @Override
    public List<EmGcrl> getList(JSONObject json) {
        QueryWrapper<EmGcrl> queryWrapper=new QueryWrapper<>();
        if(StringUtils.isNotEmpty(json.getString("nf"))){
            queryWrapper.eq("NF",json.getString("nf"));
        }
        List<EmGcrl> emGcrls=emGcrlMapper.selectList(queryWrapper);
        return emGcrls;
    }



    @Override
    public void update(List<EmGcrl> emGcrls) {
     //   emGcrlRepository.saveAll(emGcrls);
        updateBatchById(emGcrls);
    }

    @Override
    public void generate() {
        String nf=Year.now().toString();
        List<EmGcrl> emGcrlRepositoryByNf=emGcrlRepository.findByNf(nf);
        if (ObjectUtil.isEmpty(emGcrlRepositoryByNf)){
            EmGcrl emGcrl=new EmGcrl();
            Date date = new Date();//获取当前时间
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");//定义日期格式
            String dateString = dateFormat.format(date);
            emGcrl.setNf(nf);
            emGcrl.setGl(dateString);
            emGcrlMapper.insert(emGcrl);
        }
    }
}
